%{!?python3_version: %global python3_version %(%{__python3} -c "import sys; sys.stdout.write(sys.version[:3])")}

%if 0%{?fedora} > 12 || 0%{?rhel} > 6
%global with_python3 1
%endif

%if 0%{?fedora}
%{!?python3_pkgversion: %global python3_pkgversion 3}
%else
%{!?python3_pkgversion: %global python3_pkgversion 34}
%endif

%global upstream_name nose2

Name:           python-%{upstream_name}
Version:        0.4.7
Release:        3%{?dist}
Summary:        Next generation of nicer testing for Python

License:        BSD
URL:            https://nose2.readthedocs.org
Source0:        https://pypi.python.org/packages/source/n/%{upstream_name}/%{upstream_name}-%{version}.tar.gz
BuildArch:      noarch

BuildRequires:  python2-devel
BuildRequires:  python-setuptools
BuildRequires:  python-six
%if 0%{?with_python3}
BuildRequires: python3-pkgversion-macros
BuildRequires: python%{python3_pkgversion}-devel
BuildRequires: python%{python3_pkgversion}-setuptools
BuildRequires: python%{python3_pkgversion}-six
%endif

Requires:  python-six


%description
nose2 is the next generation of nicer testing for Python, based on the plugins
branch of unittest2. nose2 aims to improve on nose by:
- providing a better plugin api
- being easier for users to configure
- simplifying internal interfaces and processes
- supporting Python 2 and 3 from the same codebase, without translation
- encourging greater community involvment in its development

In service of some those goals, some features of nose will not be supported in
nose2. See the documentation for a thorough rundown.


%if 0%{?with_python3}
%package -n python%{python3_pkgversion}-%{upstream_name}
Summary:        Next generation of nicer testing for Python3
Requires:       python%{python3_pkgversion}-setuptools
Requires:       python%{python3_pkgversion}-six

%description -n python%{python3_pkgversion}-%{upstream_name}
nose2 is the next generation of nicer testing for Python, based on the plugins
branch of unittest2. nose2 aims to improve on nose by:
- providing a better plugin api
- being easier for users to configure
- simplifying internal interfaces and processes
- supporting Python 2 and 3 from the same codebase, without translation
- encourging greater community involvment in its development

In service of some those goals, some features of nose will not be supported in
nose2. See the documentation for a thorough rundown.
%endif # with_python3


%prep
%setup -q -n %{upstream_name}-%{version}
# Remove bundled egg-info
rm -rf %{upstream_name}.egg-info

%if 0%{?with_python3}
rm -rf %{py3dir}
cp -a . %{py3dir}
%endif # with_python3


%build
%{__python} setup.py build

%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py build
popd
%endif # with_python3


%install
rm -rf %{buildroot}
# Must do the python3 install first because the scripts in /usr/bin are
# overwritten with every setup.py install (and we want the python2 version
# to be the default for now).
%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py install --skip-build --root %{buildroot}
rm %{buildroot}%{_bindir}/nose2
popd
%endif # with_python3

%{__python} setup.py install --skip-build --root %{buildroot}
# Remove the versionned dependency on six
sed -i -e 's/six>=1.1,<1.4/six/g' \
    %{buildroot}%{python_sitelib}/%{upstream_name}-%{version}-py?.?.egg-info/requires.txt \
    %{buildroot}%{python3_sitelib}/%{upstream_name}-%{version}-py?.?.egg-info/requires.txt


%check
PYTHONPATH=. bin/nose2

%if 0%{?with_python3}
py2dir=`pwd`
pushd %{py3dir}
PYTHONPATH=. %{__python3} ${py2dir}/bin/nose2
popd
%endif # with_python3


%files
%defattr(-,root,root,-)
%doc README.rst license.txt
%{python_sitelib}/%{upstream_name}
%{python_sitelib}/%{upstream_name}-%{version}-py?.?.egg-info
%{_bindir}/nose2*

%if 0%{?with_python3}
%files -n python%{python3_pkgversion}-%{upstream_name}
%defattr(-,root,root,-)
%doc README.rst license.txt
%{python3_sitelib}/%{upstream_name}
%{python3_sitelib}/%{upstream_name}-%{version}-py?.?.egg-info
%{_bindir}/nose2-%{python3_version}
%endif



%changelog
* Wed Aug 28 2013 Aurelien Bompard <abompard@fedoraproject.org> - 0.4.7-1
- Initial package.
